
import java.util.ArrayList;
import java.util.Random;

import java.io.FileInputStream;
import java.util.Scanner;

public class GeoPos
{
  private final int faces;

  ArrayList<CartPoint> correct_lst;
  ArrayList<RadPoint> points = new ArrayList<>();
  int fixed_count;

  public static void main(String args[])
    throws Exception
  {
    new GeoPos(60);
  }

  public static final double distance_lock = 0.01;

  public GeoPos(int faces)
    throws Exception
  {
    this.faces = faces;

    Random rnd = new Random();

    correct_lst = readPoints("correct.txt");

    for(int i=0; i<4; i++)
    {
      points.add(correct_lst.get(i).getRad());
    }

    /*points.add(new RadPoint(2.422144104, 1.780815045));
    points.add(new RadPoint(3.141592654, 1.76179428));
    points.add(new RadPoint(-2.007678541, 1.914870038));*/


    fixed_count = points.size();

    while(points.size() < faces)
    {
      points.add(new RadPoint( rnd.nextDouble() * Math.PI * 2.0 - Math.PI,
          rnd.nextDouble() * Math.PI * 2.0 - Math.PI));
    }

    System.out.println(new RadPoint(1, 1).toString());
    System.out.println(new RadPoint(1, 1).getCart().getRad().toString());


    force_mult=0.01;
    for(int i=0; i<100000; i++)
    {
      sim();

      if (i % 10000 == 0)
      {
        System.out.println("Pass: " + i);
        printSet();
      }
    }

    force_mult=0.001;
    for(int i=0; i<1000000; i++)
    {
      sim();

      if (i % 10000 == 0)
      {
        System.out.println("Pass: " + i);
        printSet();
      }
    }

    force_mult=0.0001;
    for(int i=0; i<1000000; i++)
    {
      sim();

      if (i % 10000 == 0)
      {
        System.out.println("Pass: " + i);
        printSet();
      }
    }



  }

  public void printSet()
  {
    for(RadPoint p : points)
    {
      System.out.println(p);
    }
    int matches=0;
    for(CartPoint c : correct_lst)
    {
      for(RadPoint p : points)
      {
        if (c.getDist(p.getCart()) < distance_lock)
        {
          matches++;
          break;
        }
      }

    }
    System.out.println("Matches: " + matches + "/" + correct_lst.size());


  }

  public double force_mult = 0.001;

  public void sim()
  {
    ArrayList<RadPoint> next_points = new ArrayList<>();

    for(int i=0; i<points.size(); i++)
    {
      CartPoint vector = new CartPoint(0,0,0);

      for(int j=0;j<points.size(); j++)
      if (i != j)
      {
        RadPoint a = points.get(i);
        RadPoint b = points.get(j);
        double dist = a.getDist(b);

        //System.out.println(dist);


        double force = -force_mult/(dist * dist);

        CartPoint v = a.getCart().getDirection(b.getCart());

        v = v.multi(force);

        vector = vector.add(v);

      }
      if (i < fixed_count)
      {
        next_points.add(points.get(i));
      }
      else
      {
        next_points.add( points.get(i).getCart().add(vector).getRad());
      }
    }

    points.clear();
    points.addAll(next_points);


   

  }


  public ArrayList<CartPoint> readPoints(String filename)
    throws Exception
  {
    Scanner scan = new Scanner(new FileInputStream(filename));
    ArrayList<CartPoint> lst = new ArrayList<>();

    while(scan.hasNext())
    {
      double x,y,z;
      x = scan.nextDouble();
      y = scan.nextDouble();
      z = scan.nextDouble();

      lst.add(new CartPoint(x,y,z));


    }

    return lst;

  }

}
